<%
	myname = "menusystem.asp"
	page = request("page")
	if (page = "") then
%>
<div align="right"><font face="Verdana" size="1"><a href="<%=myname%>?page=2">Next Page &gt;</a></font></div>

<a href="samplepage.asp" target="newwindow_for_samplepage_asp">See the Menu!</a>
<hr>

Ok, so you've seen some of the Microsoft sites, for example 
<a href="http://www.microsoft.com/sql/">SQL Server</a>, and down the side of the page, they have those pretty (questionable) buttons that popup, pushin, and generally dance a little, and wondered how?
<br><Br>
The button system they used (and hence the one I have for you) is based around some JavaScript and CSS.
<br><br>
If you have ever looked at the source code of a Microsoft.com page, then you probably nearly went insane the moment you saw it: its not exactly elegant to look at, or easy to copy!
<br><br>
In this example, I have used ASP to save time on the authors part, using fuctions instead of repeatedly cut&amp;pasting code around the place.
<br><br>
Ok, the menu system is based around 6 files. These are:
<ul>
   <li><b>samplepage.asp</b>: The page the menu will appear in.</li>
   <li><b>menu.asp</b>: The file that makes the menu.</li>
   <li><b>functions.inc</b>: has all the functions I used.</li>
   <li><b>linenavdns.gif</b>: An item separator.</li>
   <li><b>menu.js</b>: Invluded into menu.asp. Does the hovering.</li>
   <li><b>menu.css</b>: The CSS styling magic.</li>
</ul>


On the next page I detail what each file does.<br>
<div align="right"><font face="Verdana" size="1"><a href="<%=myname%>?page=2">Next Page &gt;</a></font></div>

<%	
	ElseIf (page = "2") Then
%>

<div align="right"><font face="Verdana" size="1"><a href="<%=myname%>">&lt; Prev Page </a> &nbsp;<a href="<%=myname%>?page=3">Next Page &gt;</a></font></div>

You will need to grab the code for the menu, if you want to have a play, as the files themselves are a little large to include within the article :) Sorry.
<br><Br>

I think I'll start at the bottom of the list. <br><br>

<B>menu.css</b>:<Br>
MENU.css contains the styling of the buttons in each of it states. There are 4 types of buttons on the menu: Normal, Normal-Sub, Chosen, Chosen-Sub. Each of these have 4 states: Off, MouseOver, MouseDown, MouseClicked. In total there are 16 styles. Changing the color here will change the colors of the menu. <br><br>

<b>menu.js</b>:<Br>
The client side code is here. It is included into the menu generator on the serverside, due to problems with Navigator 3 running any old code it comes across when using the &lt;script src=""&gt; tag. Its probably best if you don't muck around with this one too much.<br><Br>

<b>linenavdns.gif</b>:<BR>
This is a 2 pixel high image, used as a seperator in the menu. Equivelent to an HR, but just looks a little nicer. If you change the background color of the menu, you will need to change the colors of this image.<bR><BR>

<b>functions.inc</b>:<BR>
The server side code is here. If you change the color of text in the menu.css file, you will also need to make changes to some of the fuctions in here. I will detail this further on.<br><Br>

<b>menu.asp</b>:<BR>
This file makes the menu, includes the calls to functions etc. Any pages you want the menu to appear on just need to include this file.<Br><Br>

<b>samplepage.asp</b>:<BR>
See the menu in all its glory within another page!<br><Br>

Ok, now you know what each file does, we'll get into the fun part: making your own menu!

<div align="right"><font face="Verdana" size="1"><a href="<%=myname%>">&lt; Prev Page </a> &nbsp;<a href="<%=myname%>?page=3">Next Page &gt;</a></font></div>

<%
	ElseIf (page = "3") Then
%>
<div align="right"><font face="Verdana" size="1"><a href="<%=myname%>?page=2">&lt; Prev Page </a> &nbsp;<a href="<%=myname%>?page=4">Next Page &gt;</a></font></div>

So, you've had a look at the sample menu (if you haven't <a href="samplepage.asp" target="newwindow_for_samplepage_asp">take a look</a> now), and you're thinking that maybe you would like to try it?<br><BR>

I'd suggest grabbing the source right now, if you dont have it already. You'll understand what I'm going on about shortly, if you have the files detailed above.<Br><bR>

There are 4 types of buttons, as I mentioned in the file description of menu.css. In the sample menu, I've used all of them. In the menu.asp file, you can create your own buttons using simple VBScript subroutines.<Br><Br>

The top item, which is incidentally fish, like all the rest, can be made by adding the following line to menu.asp:<BR>
<code> call drawMenu(Text of button, URL to go to)</code>. You just change those two values to whatever you like. <BR><br>

The second item, which is indented, just like the last item on the sample menu, can be made by adding: <codE>call drawSubMenu(Text of button, URL to go to)</code>. <br><br>

On the sample menu, there is the linenavdns.gif image I detailed on the previous page. You can insert this seperator at any point by adding this code: <code>call drawMenuSeperator()</code>.
<Br><br>

The third item, the orange with dot one, can be made by adding: <code>call drawChsnMenu (Text of button, URL to go to).<br><br>

The fourth item, the indented orange with dot, can be made by adding: <code>call drawChsnSubMenu (Text of button, URL to go to).<br><Br>

The fifth item is just the same as the second one.<br><Br>

On the next page I will explain how to customize the colors of the Button Menu.
<div align="right"><font face="Verdana" size="1"><a href="<%=myname%>?page=2">&lt; Prev Page </a> &nbsp;<a href="<%=myname%>?page=4">Next Page &gt;</a></font></div>

<%
	ElseIf (page = "4") Then
%>
<div align="right"><font face="Verdana" size="1"><a href="<%=myname%>?page=3">&lt; Prev Page </a> </font></div>

Customizing the colors of the Button Menu, isn't really as easy as it could be, but for demonstration purposes it's fine.<br><Br>

To change the background color of the menu, you will need to change the bgcolor of the table in menu.asp, and also each of the background colors within menu.css. You may also need to change the border colors of menu.css. I, personnaly, reccomend using a CSS/stylesheet editor, such as <a href="http://www.bradsoft.com/">TopStyle</a>. They have a lite version available, which is excellent.<br><br>

If you are going to change the button text colors, you will also need to change the color= portions of the &lt;font&gt; tags within functions.inc, otherwise users without support for CSS may see the menu differently.<br><br>

This last portion brings me to another point: The menu should look fine for users without CSS and JavaScript: without JavaScript it wont popup, or pushin, but it will still look the way you intended. For users without CSS, they will see it slightly differently, But they should still have a completely useable menu system.<br><br>

If you would like to make feedback on the code or this article, please send email to me @: <a href="mailto:patrickq@ihug.co.nz">patrickq@ihug.co.nz</a>.

<div align="right"><font face="Verdana" size="1"><a href="<%=myname%>?page=3">&lt; Prev Page </a> </font></div>

<%
	End If
%>